#include "Matrix.h"

void Matrix::resetSize(int _N, int _M) {

	// IɊmۂ̈
	for (int i = 0; i<N; i++) delete[] elements[i];
	delete[] elements;
	N = _N;
	M = _M;
	//߂Ċm
	elements = new double*[N];
	for (int i = 0; i<N; i++) {
		elements[i] = new double[M];
		for (int j = 0; j < M; j++) {
			elements[i][j] = 0;
		}
	}

}
void Matrix::set(int i, int j, double value) {

	elements[i][j] = value;

}
double Matrix::get(int i, int j) {

	return elements[i][j];

}
void Matrix::copy(const Matrix& m) {

	resetSize(m.N, m.M);

	for (int i = 0; i < N; i++) {
		for (int j = 0; j < M; j++) {

			elements[i][j] = m.elements[i][j];

		}

	}

}
//]usԂ
Matrix Matrix::transpose(Matrix& m) {
	Matrix temp(m.M, m.N);
	for (int i = 0; i < m.M; i++) {
		for (int j = 0; j < m.N; j++) {
			temp.elements[i][j] = m.elements[j][i];
		}
	}
	return temp;
}


Matrix Matrix::clone() {
	Matrix temp(N, M);
	temp.copy(*this);
	return temp;
}
double* Matrix::operator[](int i) {
	return elements[i];
}
double Matrix::operator()(int i, int j) {
	return elements[i][j];
}

//I[o[[hu=v
Matrix& Matrix::operator = (const Matrix& m) {

	copy(m);
	return *this;

}
Matrix operator * (const Matrix& m1, const Matrix& m2) {
	if (m1.M != m2.N) {
		std::cout << "s̃TCYςɑΉĂ܂" << std::endl;
		return Matrix();
	}
	int N1 = m1.N;
	int M1 = m1.M;
	int N2 = m2.N;
	int M2 = m2.M;
	Matrix temp(N1, M2);
	for (int i = 0; i<N1; i++) {
		for (int j = 0; j<M2; j++) {
			temp.elements[i][j] = 0;
			for (int k = 0; k<N2; k++) {
				temp.elements[i][j] += m1.elements[i][k] * m2.elements[k][j];
			}
		}
	}

	return temp;
}
Matrix& Matrix::multiplyMatries(Matrix& m1, Matrix& m2, Matrix& out) {
	int N1 = m1.N;
	int M1 = m1.M;
	int N2 = m2.N;
	int M2 = m2.M;
	for (int i = 0; i<N1; i++) {
		for (int j = 0; j<M2; j++) {
			out.elements[i][j] = 0;
			for (int k = 0; k<N2; k++) {
				out.elements[i][j] += m1.elements[i][k] * m2.elements[k][j];
			}
		}
	}
	return out;
}
Matrix& Matrix::multiply(const Matrix& m) {

	int N2 = m.N;
	int M2 = m.M;
	for (int i = 0; i<N; i++) {
		for (int j = 0; j<M2; j++) {
			double e = 0;
			for (int k = 0; k<N2; k++) {
				e += elements[i][k] * m.elements[k][j];
			}
			elements[i][j] = e;
		}
	}
	return (*this);
}
Matrix& Matrix::add(const Matrix& m) {
	int N2 = m.N;
	int M2 = m.M;
	for (int i = 0; i<N2; i++) {
		for (int j = 0; j<M2; j++) {
			elements[i][j] += m.elements[i][j];
		}
	}
	return (*this);
}

Matrix operator - (const Matrix& m1, const Matrix& m2) {
	if (m1.N != m2.N || m1.M != m2.M) {
		std::cout << "s̃TCYɑΉĂ܂" << std::endl;
		return Matrix();
	}
	int N2 = m2.N;
	int M2 = m2.M;
	Matrix temp(N2, M2);

	for (int i = 0; i<N2; i++) {
		for (int j = 0; j<M2; j++) {
			temp.elements[i][j] = m1.elements[i][j] - m2.elements[i][j];
		}
	}
	return temp;
}
Matrix operator + (const Matrix& m1, const Matrix& m2) {
	if (m1.N != m2.N || m1.M != m2.M){
		std::cout << "s̃TCYaɑΉĂ܂" << std::endl;
		return Matrix();
	}
	int N2 = m2.N;
	int M2 = m2.M;
	Matrix temp(N2, M2);

	for (int i = 0; i<N2; i++) {
		for (int j = 0; j<M2; j++) {
			temp.elements[i][j] = m1.elements[i][j] + m2.elements[i][j];
		}
	}
	return temp;
}